<?php
$config->workflowaction->require = new stdclass();
$config->workflowaction->require->create = 'action, name';
$config->workflowaction->require->edit   = 'action, name';

$config->workflowaction->uniqueFields = 'action, name';

$config->workflowaction->operatorList['equal']    = '=';
$config->workflowaction->operatorList['notequal'] = '!=';
$config->workflowaction->operatorList['gt']       = '>';
$config->workflowaction->operatorList['ge']       = '>=';
$config->workflowaction->operatorList['lt']       = '<';
$config->workflowaction->operatorList['le']       = '<=';

$config->workflowaction->default = new stdclass();
$config->workflowaction->default->actions      = array('browse', 'create', 'batchcreate', 'edit', 'view', 'delete', 'link', 'unlink', 'export', 'exporttemplate', 'import', 'showimport', 'report');  // These actions are real methods in flow/control.php;
$config->workflowaction->default->extraActions = array('assign', 'batchedit', 'batchassign');   // These actions will be called by the operate method or the batchOperate method in flow/control.php.

$config->workflowaction->default->statuses['browse']         = 'enable';
$config->workflowaction->default->statuses['create']         = 'enable';
$config->workflowaction->default->statuses['batchcreate']    = 'disable';
$config->workflowaction->default->statuses['batchedit']      = 'disable';
$config->workflowaction->default->statuses['batchassign']    = 'disable';
$config->workflowaction->default->statuses['edit']           = 'enable';
$config->workflowaction->default->statuses['view']           = 'enable';
$config->workflowaction->default->statuses['assign']         = 'disable';
$config->workflowaction->default->statuses['delete']         = 'enable';
$config->workflowaction->default->statuses['link']           = 'disable';
$config->workflowaction->default->statuses['unlink']         = 'disable';
$config->workflowaction->default->statuses['export']         = 'disable';
$config->workflowaction->default->statuses['exporttemplate'] = 'disable';
$config->workflowaction->default->statuses['import']         = 'disable';
$config->workflowaction->default->statuses['showimport']     = 'disable';
$config->workflowaction->default->statuses['report']         = 'disable';

$config->workflowaction->default->types['browse']         = 'single';
$config->workflowaction->default->types['create']         = 'single';
$config->workflowaction->default->types['batchcreate']    = 'batch';
$config->workflowaction->default->types['batchedit']      = 'batch';
$config->workflowaction->default->types['batchassign']    = 'batch';
$config->workflowaction->default->types['edit']           = 'single';
$config->workflowaction->default->types['view']           = 'single';
$config->workflowaction->default->types['assign']         = 'single';
$config->workflowaction->default->types['delete']         = 'single';
$config->workflowaction->default->types['link']           = 'single';
$config->workflowaction->default->types['unlink']         = 'single';
$config->workflowaction->default->types['export']         = 'single';
$config->workflowaction->default->types['exporttemplate'] = 'single';
$config->workflowaction->default->types['import']         = 'single';
$config->workflowaction->default->types['showimport']     = 'single';
$config->workflowaction->default->types['report']         = 'single';

$config->workflowaction->default->batchModes['browse']         = 'same';
$config->workflowaction->default->batchModes['create']         = 'same';
$config->workflowaction->default->batchModes['batchcreate']    = 'different';
$config->workflowaction->default->batchModes['batchedit']      = 'different';
$config->workflowaction->default->batchModes['batchassign']    = 'same';
$config->workflowaction->default->batchModes['edit']           = 'same';
$config->workflowaction->default->batchModes['view']           = 'same';
$config->workflowaction->default->batchModes['assign']         = 'same';
$config->workflowaction->default->batchModes['delete']         = 'same';
$config->workflowaction->default->batchModes['link']           = 'same';
$config->workflowaction->default->batchModes['unlink']         = 'same';
$config->workflowaction->default->batchModes['export']         = 'same';
$config->workflowaction->default->batchModes['exporttemplate'] = 'same';
$config->workflowaction->default->batchModes['import']         = 'same';
$config->workflowaction->default->batchModes['showimport']     = 'same';
$config->workflowaction->default->batchModes['report']         = 'same';

$config->workflowaction->default->opens['browse']         = 'normal';
$config->workflowaction->default->opens['create']         = 'normal';
$config->workflowaction->default->opens['batchcreate']    = 'normal';
$config->workflowaction->default->opens['batchedit']      = 'normal';
$config->workflowaction->default->opens['batchassign']    = 'normal';
$config->workflowaction->default->opens['edit']           = 'normal';
$config->workflowaction->default->opens['view']           = 'normal';
$config->workflowaction->default->opens['assign']         = 'modal';
$config->workflowaction->default->opens['delete']         = 'none';
$config->workflowaction->default->opens['link']           = 'none';
$config->workflowaction->default->opens['unlink']         = 'none';
$config->workflowaction->default->opens['export']         = 'none';
$config->workflowaction->default->opens['exporttemplate'] = 'none';
$config->workflowaction->default->opens['import']         = 'none';
$config->workflowaction->default->opens['showimport']     = 'none';
$config->workflowaction->default->opens['report']         = 'none';

$config->workflowaction->default->positions['browse']         = 'menu';
$config->workflowaction->default->positions['create']         = 'menu';
$config->workflowaction->default->positions['batchcreate']    = 'menu';
$config->workflowaction->default->positions['batchedit']      = 'browse';
$config->workflowaction->default->positions['batchassign']    = 'browse';
$config->workflowaction->default->positions['edit']           = 'browseandview';
$config->workflowaction->default->positions['view']           = 'browse';
$config->workflowaction->default->positions['assign']         = 'browseandview';
$config->workflowaction->default->positions['delete']         = 'browseandview';
$config->workflowaction->default->positions['link']           = 'view';
$config->workflowaction->default->positions['unlink']         = 'view';
$config->workflowaction->default->positions['export']         = 'menu';
$config->workflowaction->default->positions['exporttemplate'] = 'menu';
$config->workflowaction->default->positions['import']         = 'menu';
$config->workflowaction->default->positions['showimport']     = 'menu';
$config->workflowaction->default->positions['report']         = 'menu';

$config->workflowaction->defaultActions        = array_merge($config->workflowaction->default->actions, $config->workflowaction->default->extraActions);
$config->workflowaction->noDisableActions      = array('browse', 'create', 'edit', 'view', 'delete');
$config->workflowaction->noShowActions         = array('browse', 'create', 'export', 'exporttemplate', 'import', 'showimport', 'link', 'unlink', 'report', 'batchcreate', 'batchedit', 'batchassign');
$config->workflowaction->readonlyActions       = array('browse', 'view',   'export', 'exporttemplate', 'import', 'showimport', 'link', 'unlink', 'report', 'delete');
$config->workflowaction->noLinkageActions      = array('browse', 'view',   'export', 'exporttemplate', 'import', 'showimport', 'link', 'unlink', 'report', 'delete');
$config->workflowaction->noConditionActions    = array('browse', 'view',   'export', 'exporttemplate', 'import', 'showimport', 'report', 'create', 'batchcreate');
$config->workflowaction->noVerificationActions = array('browse', 'view',   'export', 'exporttemplate', 'import', 'showimport', 'link', 'unlink', 'report', 'delete');
$config->workflowaction->noHookActions         = array('browse', 'view',   'export', 'exporttemplate', 'import', 'showimport', 'link', 'unlink', 'report');
$config->workflowaction->noNoticeActions       = array('browse', 'view',   'export', 'exporttemplate', 'import', 'showimport', 'link', 'unlink', 'report', 'delete');
$config->workflowaction->noJSActions           = array('export', 'exporttemplate', 'import', 'showimport', 'unlink', 'delete');
$config->workflowaction->noCSSActions          = array('export', 'exporttemplate', 'import', 'showimport', 'unlink', 'delete');

$config->workflowaction->buildin = new stdclass();
$config->workflowaction->buildin->actions['crm']['order']            = array('browse', 'create', 'edit', 'view', 'assign', 'close', 'activate', 'team', 'operate', 'delete', 'batchassign', 'export');
$config->workflowaction->buildin->actions['crm']['contract']         = array('browse', 'create', 'edit', 'view', 'invoice', 'createquotation', 'delivery', 'receive', 'finish', 'expense', 'manageteam', 'cancel', 'delete', 'export');
$config->workflowaction->buildin->actions['crm']['purchasecontract'] = array('browse', 'create', 'edit', 'view', 'finish', 'expense', 'pay', 'cancel', 'delete', 'export');
$config->workflowaction->buildin->actions['crm']['customer']         = array('browse', 'create', 'edit', 'view', 'assign', 'contact', 'order', 'contract', 'merge', 'invoice', 'invoiceinfo', 'delete', 'batchassign', 'export', 'exporttemplate', 'import');
$config->workflowaction->buildin->actions['crm']['provider']         = array('browse', 'create', 'edit', 'view', 'merge', 'delete');
$config->workflowaction->buildin->actions['crm']['contact']          = array('browse', 'create', 'edit', 'view', 'vcard', 'delete', 'export', 'exporttemplate', 'import');
$config->workflowaction->buildin->actions['crm']['leads']            = array('browse', 'assignedtonull', 'create', 'edit', 'view', 'assign', 'transform', 'ignore', 'delete', 'batchassign', 'batchignore');
$config->workflowaction->buildin->actions['crm']['product']          = array('browse', 'create', 'edit', 'view', 'adminfield', 'adminaction', 'copy', 'delete', 'batchcreate');
$config->workflowaction->buildin->actions['crm']['invoice']          = array('browsesale', 'browsepurchase', 'createsale', 'createpurchase', 'edit', 'view', 'drawn', 'express', 'taxrefund', 'delete', 'export');
$config->workflowaction->buildin->actions['crm']['feedback']         = array('company', 'personal', 'create', 'edit', 'view', 'assign', 'doubt', 'reply', 'close', 'activate', 'delete');

/* If the action's type is batch, write here. */
$config->workflowaction->buildin->types['crm']['order']['batchassign']    = 'batch';
$config->workflowaction->buildin->types['crm']['customer']['batchassign'] = 'batch';
$config->workflowaction->buildin->types['crm']['leads']['batchassign']    = 'batch';
$config->workflowaction->buildin->types['crm']['leads']['batchignore']    = 'batch';
$config->workflowaction->buildin->types['crm']['product']['batchcreate']  = 'batch';

/* If the action's batchModes is differend, write here. */
$config->workflowaction->buildin->batchModes['crm']['product']['batchcreate'] = 'different';

/* If the action's open way is not normal, write here. */
$config->workflowaction->buildin->opens['crm']['order']['assign']             = 'modal';
$config->workflowaction->buildin->opens['crm']['order']['close']              = 'modal';
$config->workflowaction->buildin->opens['crm']['order']['activate']           = 'modal';
$config->workflowaction->buildin->opens['crm']['order']['team']               = 'modal';
$config->workflowaction->buildin->opens['crm']['order']['operate']            = 'none';
$config->workflowaction->buildin->opens['crm']['order']['delete']             = 'none';
$config->workflowaction->buildin->opens['crm']['order']['batchassign']        = 'normal';
$config->workflowaction->buildin->opens['crm']['order']['export']             = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['invoice']         = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['createquotation'] = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['delivery']        = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['receive']         = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['manageteam']      = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['finish']          = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['expense']         = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['cancel']          = 'modal';
$config->workflowaction->buildin->opens['crm']['contract']['delete']          = 'none';
$config->workflowaction->buildin->opens['crm']['contract']['export']          = 'modal';
$config->workflowaction->buildin->opens['crm']['purchasecontract']['finish']  = 'modal';
$config->workflowaction->buildin->opens['crm']['purchasecontract']['expense'] = 'modal';
$config->workflowaction->buildin->opens['crm']['purchasecontract']['pay']     = 'modal';
$config->workflowaction->buildin->opens['crm']['purchasecontract']['cancel']  = 'modal';
$config->workflowaction->buildin->opens['crm']['purchasecontract']['delete']  = 'none';
$config->workflowaction->buildin->opens['crm']['purchasecontract']['export']  = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['assign']          = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['contact']         = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['order']           = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['contract']        = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['merge']           = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['invoice']         = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['invoiceinfo']     = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['delete']          = 'none';
$config->workflowaction->buildin->opens['crm']['customer']['batchassign']     = 'normal';
$config->workflowaction->buildin->opens['crm']['customer']['export']          = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['exporttemplate']  = 'modal';
$config->workflowaction->buildin->opens['crm']['customer']['import']          = 'modal';
$config->workflowaction->buildin->opens['crm']['provider']['merge']           = 'modal';
$config->workflowaction->buildin->opens['crm']['provider']['delete']          = 'none';
$config->workflowaction->buildin->opens['crm']['contact']['vcard']            = 'modal';
$config->workflowaction->buildin->opens['crm']['contact']['delete']           = 'none';
$config->workflowaction->buildin->opens['crm']['contact']['export']           = 'modal';
$config->workflowaction->buildin->opens['crm']['contact']['exporttemplate']   = 'modal';
$config->workflowaction->buildin->opens['crm']['contact']['import']           = 'modal';
$config->workflowaction->buildin->opens['crm']['leads']['assign']             = 'modal';
$config->workflowaction->buildin->opens['crm']['leads']['ignore']             = 'normal';
$config->workflowaction->buildin->opens['crm']['leads']['transform']          = 'modal';
$config->workflowaction->buildin->opens['crm']['leads']['delete']             = 'none';
$config->workflowaction->buildin->opens['crm']['leads']['batchassign']        = 'normal';
$config->workflowaction->buildin->opens['crm']['leads']['batchignore']        = 'normal';
$config->workflowaction->buildin->opens['crm']['product']['create']           = 'modal';
$config->workflowaction->buildin->opens['crm']['product']['edit']             = 'modal';
$config->workflowaction->buildin->opens['crm']['product']['adminfield']       = 'none';
$config->workflowaction->buildin->opens['crm']['product']['adminaction']      = 'none';
$config->workflowaction->buildin->opens['crm']['product']['copy']             = 'modal';
$config->workflowaction->buildin->opens['crm']['product']['delete']           = 'none';
$config->workflowaction->buildin->opens['crm']['invoice']['drawn']            = 'modal';
$config->workflowaction->buildin->opens['crm']['invoice']['express']          = 'modal';
$config->workflowaction->buildin->opens['crm']['invoice']['taxrefund']        = 'modal';
$config->workflowaction->buildin->opens['crm']['invoice']['delete']           = 'none';
$config->workflowaction->buildin->opens['crm']['invoice']['export']           = 'modal';
$config->workflowaction->buildin->opens['crm']['feedback']['assign']          = 'modal';
$config->workflowaction->buildin->opens['crm']['feedback']['doubt']           = 'modal';
$config->workflowaction->buildin->opens['crm']['feedback']['reply']           = 'modal';
$config->workflowaction->buildin->opens['crm']['feedback']['close']           = 'modal';
$config->workflowaction->buildin->opens['crm']['feedback']['activate']        = 'modal';
$config->workflowaction->buildin->opens['crm']['feedback']['delete']          = 'none';

/* If the action's positions is not browseandview, write here. */
$config->workflowaction->buildin->positions['crm']['order']['browse']             = 'menu';
$config->workflowaction->buildin->positions['crm']['order']['create']             = 'menu';
$config->workflowaction->buildin->positions['crm']['order']['view']               = 'browse';
$config->workflowaction->buildin->positions['crm']['order']['batchassign']        = 'browse';
$config->workflowaction->buildin->positions['crm']['order']['export']             = 'menu';
$config->workflowaction->buildin->positions['crm']['contract']['browse']          = 'menu';
$config->workflowaction->buildin->positions['crm']['contract']['expense']         = 'view';
$config->workflowaction->buildin->positions['crm']['contract']['create']          = 'menu';
$config->workflowaction->buildin->positions['crm']['contract']['view']            = 'browse';
$config->workflowaction->buildin->positions['crm']['contract']['export']          = 'menu';
$config->workflowaction->buildin->positions['crm']['purchasecontract']['browse']  = 'menu';
$config->workflowaction->buildin->positions['crm']['purchasecontract']['expense'] = 'view';
$config->workflowaction->buildin->positions['crm']['purchasecontract']['create']  = 'menu';
$config->workflowaction->buildin->positions['crm']['purchasecontract']['view']    = 'browse';
$config->workflowaction->buildin->positions['crm']['purchasecontract']['export']  = 'menu';
$config->workflowaction->buildin->positions['crm']['customer']['browse']          = 'menu';
$config->workflowaction->buildin->positions['crm']['customer']['create']          = 'menu';
$config->workflowaction->buildin->positions['crm']['customer']['order']           = 'browse';
$config->workflowaction->buildin->positions['crm']['customer']['view']            = 'browse';
$config->workflowaction->buildin->positions['crm']['customer']['batchassign']     = 'browse';
$config->workflowaction->buildin->positions['crm']['customer']['export']          = 'menu';
$config->workflowaction->buildin->positions['crm']['customer']['exporttemplate']  = 'menu';
$config->workflowaction->buildin->positions['crm']['customer']['import']          = 'menu';
$config->workflowaction->buildin->positions['crm']['provider']['browse']          = 'menu';
$config->workflowaction->buildin->positions['crm']['provider']['create']          = 'menu';
$config->workflowaction->buildin->positions['crm']['provider']['view']            = 'browse';
$config->workflowaction->buildin->positions['crm']['contact']['browse']           = 'menu';
$config->workflowaction->buildin->positions['crm']['contact']['create']           = 'menu';
$config->workflowaction->buildin->positions['crm']['contact']['view']             = 'browse';
$config->workflowaction->buildin->positions['crm']['contact']['export']           = 'menu';
$config->workflowaction->buildin->positions['crm']['contact']['exporttemplate']   = 'menu';
$config->workflowaction->buildin->positions['crm']['contact']['import']           = 'menu';
$config->workflowaction->buildin->positions['crm']['leads']['browse']             = 'menu';
$config->workflowaction->buildin->positions['crm']['leads']['create']             = 'menu';
$config->workflowaction->buildin->positions['crm']['leads']['view']               = 'browse';
$config->workflowaction->buildin->positions['crm']['leads']['batchassign']        = 'browse';
$config->workflowaction->buildin->positions['crm']['leads']['batchignore']        = 'browse';
$config->workflowaction->buildin->positions['crm']['product']['browse']           = 'menu';
$config->workflowaction->buildin->positions['crm']['product']['create']           = 'menu';
$config->workflowaction->buildin->positions['crm']['product']['view']             = 'browse';
$config->workflowaction->buildin->positions['crm']['product']['adminfield']       = 'browse';
$config->workflowaction->buildin->positions['crm']['product']['adminaction']      = 'browse';
$config->workflowaction->buildin->positions['crm']['product']['copy']             = 'browse';
$config->workflowaction->buildin->positions['crm']['product']['batchcreate']      = 'menu';
$config->workflowaction->buildin->positions['crm']['invoice']['browsesale']       = 'menu';
$config->workflowaction->buildin->positions['crm']['invoice']['browsepurchase']   = 'menu';
$config->workflowaction->buildin->positions['crm']['invoice']['createsale']       = 'menu';
$config->workflowaction->buildin->positions['crm']['invoice']['createpurchase']   = 'menu';
$config->workflowaction->buildin->positions['crm']['invoice']['view']             = 'browse';
$config->workflowaction->buildin->positions['crm']['invoice']['export']           = 'menu';
$config->workflowaction->buildin->positions['crm']['feedback']['company']         = 'menu';
$config->workflowaction->buildin->positions['crm']['feedback']['personal']        = 'menu';
$config->workflowaction->buildin->positions['crm']['feedback']['create']          = 'menu';
$config->workflowaction->buildin->positions['crm']['feedback']['view']            = 'browse';
$config->workflowaction->buildin->positions['crm']['feedback']['reply']           = 'view';
$config->workflowaction->buildin->positions['crm']['feedback']['doubt']           = 'view';

/* If the action's layout is left and right columns, write here. The value should be main or side? */
$config->workflowaction->buildin->layouts['crm']['order']['edit']            = 'side';
$config->workflowaction->buildin->layouts['crm']['order']['view']            = 'side';
$config->workflowaction->buildin->layouts['crm']['contract']['edit']         = 'side';
$config->workflowaction->buildin->layouts['crm']['contract']['view']         = 'side';
$config->workflowaction->buildin->layouts['crm']['purchasecontract']['edit'] = 'side';
$config->workflowaction->buildin->layouts['crm']['purchasecontract']['view'] = 'side';
$config->workflowaction->buildin->layouts['crm']['customer']['edit']         = 'side';
$config->workflowaction->buildin->layouts['crm']['customer']['view']         = 'side';
$config->workflowaction->buildin->layouts['crm']['provider']['view']         = 'side';
$config->workflowaction->buildin->layouts['crm']['contact']['view']          = 'side';
$config->workflowaction->buildin->layouts['crm']['leads']['view']            = 'side';
$config->workflowaction->buildin->layouts['crm']['product']['view']          = 'side';
$config->workflowaction->buildin->layouts['crm']['invoice']['edit']          = 'side';
$config->workflowaction->buildin->layouts['crm']['invoice']['view']          = 'side';
$config->workflowaction->buildin->layouts['crm']['feedback']['view']         = 'side';

/* If the action's layout is dropdownlist, write here. */
$config->workflowaction->buildin->shows['crm']['order']['assign']             = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['order']['close']              = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['order']['team']               = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['order']['operate']            = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['order']['activate']           = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['order']['delete']             = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['contract']['invoice']         = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['contract']['createquotation'] = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['contract']['cancel']          = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['contract']['manageteam']      = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['contract']['delete']          = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['purchasecontract']['cancel']  = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['purchasecontract']['delete']  = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['customer']['order']           = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['customer']['contract']        = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['customer']['merge']           = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['customer']['delete']          = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['customer']['invoice']         = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['customer']['invoiceinfo']     = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['contact']['vcard']            = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['contact']['delete']           = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['product']['adminfield']       = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['product']['adminaction']      = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['product']['copy']             = 'dropdownlist';
$config->workflowaction->buildin->shows['crm']['product']['delete']           = 'dropdownlist';
